<?php
declare(strict_types=1);

namespace SwaggerBakeTest\App\Model\Entity;

use Cake\ORM\Entity;
use SwaggerBake\Lib\Attribute\OpenApiSchemaProperty;

#[OpenApiSchemaProperty(name: 'gender', example: 'female', enum: ['male','female','other'])]
#[OpenApiSchemaProperty(name: 'last_name', minLength: 3, maxLength: 59, pattern: '/\W/')]
class Employee extends Entity
{
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'first_name' => true,
        'last_name' => true,
        'gender' => true,
        'hire_date' => true,
        'birth_date' => true,
        'write' => true,
        '*' => false
    ];

    protected $_hidden = [
        'hide', 'write'
    ];
}
